<div class="sub-page-container">
  <!-- Title -->
  <h1>{{ 'parameter.site.title' | translate }}</h1>
  <mat-divider></mat-divider>
  <div class="sub-page-body" *ngIf="site | async; let siteValues">
    <div class="left-container">
      <div class="grid">
        <!-- 
          Surface Roughness 
        -->
        <div class="grid-item surface-roughness">
          <div class="title">
            <h2>{{ 'parameter.site.sourfaceRoughness' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.site.sourfaceRoughnessDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #surface
            *ngIf="siteValues && siteValues.surface_roughness"
            [unit]="this.schema?.site?.properties?.surface_roughness?.unit"
            [min]="this.schema?.site?.properties?.surface_roughness?.minimum"
            [max]="this.schema?.site?.properties?.surface_roughness?.maximum"
            [step]="this.schema?.site?.properties?.surface_roughness?.step"
            [value]="siteValues.surface_roughness"
            (valueChange)="siteValues.surface_roughness = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Field Boundaries 
        -->
        <div class="grid-item field-boundaries">
          <ng-container
            *ngIf="siteValues && siteValues.field_boundaries_long_lat"
          >
            <div class="title">
              <h2>{{ 'parameter.site.fieldBoundary' | translate }}</h2>
              <mat-icon
                [matTooltip]="
                  'parameter.site.fieldBoundaryDescription' | translate
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon>
            </div>
            <div
              class="coordinate"
              *ngFor="let point of fieldBoundaries; index as i"
            >
              <mat-form-field appearance="outline">
                <mat-label>{{ 'Point ' + (i + 1) + ' Latitude' }}</mat-label>
                <input
                  matInput
                  [ngModel]="point['lat']"
                  (ngModelChange)="changeFieldBoundaryLat($event, i)"
                  placeholder="0"
                  required
                  type="number"
                  [name]="'point' + i + 'Lat'"
                />
              </mat-form-field>
              <mat-form-field appearance="outline">
                <mat-label>{{ 'Point ' + (i + 1) + ' Longitude' }}</mat-label>
                <input
                  matInput
                  [ngModel]="point['lng']"
                  (ngModelChange)="changeFieldBoundaryLng($event, i)"
                  placeholder="0"
                  required
                  type="number"
                  [name]="'point' + i + 'Lng'"
                />
              </mat-form-field>
              <mat-icon
                (click)="removeFieldBoundaryPoint(i)"
                [matTooltip]="'parameter.site.removePoint' | translate"
                >delete_outlined</mat-icon
              >
            </div>
            <button
              mat-button
              class="stroked-pill-button"
              (click)="addFieldBoundaryPoint()"
            >
              <mat-icon
                class="add-coordinate"
                [matTooltip]="'parameter.site.addPoint' | translate"
                >add</mat-icon
              >
            </button>
          </ng-container>
        </div>
        <!-- 
          Substations 
        -->
        <div class="grid-item substations">
          <ng-container
            *ngIf="siteValues && siteValues.field_boundaries_long_lat"
          >
            <div class="title">
              <h2>{{ 'parameter.site.substations' | translate }}</h2>
              <mat-icon
                [matTooltip]="
                  'parameter.site.substationsDescription' | translate
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon>
            </div>
            <ng-container *ngIf="site">
              <div
                class="coordinate"
                *ngFor="let substation of substations; index as i"
              >
                <mat-form-field appearance="outline">
                  <mat-label>{{ 'Point ' + (i + 1) + ' Latitude' }}</mat-label>
                  <input
                    matInput
                    [ngModel]="substation['lat']"
                    (ngModelChange)="changeSubstationLat($event, i)"
                    placeholder="0"
                    required
                    type="number"
                    [name]="'point' + i + 'Lat'"
                  />
                </mat-form-field>
                <mat-form-field appearance="outline">
                  <mat-label>{{ 'Point ' + (i + 1) + ' Longitude' }}</mat-label>
                  <input
                    matInput
                    [ngModel]="substation['lng']"
                    (ngModelChange)="changeSubstationLng($event, i)"
                    placeholder="0"
                    required
                    type="number"
                    [name]="'point' + i + 'Lng'"
                  />
                </mat-form-field>
                <mat-icon
                  (click)="removeSubstation(i)"
                  [matTooltip]="'parameter.site.removePoint' | translate"
                  >delete_outlined</mat-icon
                >
              </div>
              <button
                mat-button
                class="stroked-pill-button"
                (click)="addSubstation()"
              >
                <mat-icon
                  class="add-coordinate"
                  [matTooltip]="'parameter.site.addPoint' | translate"
                  >add</mat-icon
                >
              </button>
            </ng-container>
          </ng-container>
        </div>
        <!-- 
          Restricted Area 
        -->
        <ng-container
          *ngIf="siteValues && siteValues.restricted_areas_long_lat"
        >
          <div
            class="grid-item restricted-area"
            *ngFor="let restrictedArea of restrictedAreas; index as i"
          >
            <div class="title">
              <h2>
                {{
                  ('parameter.site.restrictedArea' | translate) + ' ' + (i + 1)
                }}
              </h2>
              <mat-icon
                [matTooltip]="
                  'parameter.site.restrictedAreaDescription' | translate
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon>
            </div>
            <mat-icon
              class="delete-icon"
              (click)="removeRestrictedArea(i)"
              [matTooltip]="'parameter.site.removeRestrictedArea' | translate"
              >delete_outlined</mat-icon
            >
            <ng-container *ngIf="site">
              <div
                class="coordinate"
                *ngFor="let point of restrictedArea; index as pointIndex"
              >
                <mat-form-field appearance="outline">
                  <mat-label>{{
                    'Point ' + (pointIndex + 1) + ' Latitude'
                  }}</mat-label>
                  <input
                    matInput
                    [ngModel]="point['lat']"
                    (ngModelChange)="
                      changeRestrictedAreaLat($event, i, pointIndex)
                    "
                    placeholder="0"
                    required
                    type="number"
                    [name]="'point' + i + 'Lat'"
                  />
                </mat-form-field>
                <mat-form-field appearance="outline">
                  <mat-label>{{
                    'Point ' + (pointIndex + 1) + ' Longitude'
                  }}</mat-label>
                  <input
                    matInput
                    [ngModel]="point['lng']"
                    (ngModelChange)="
                      changeRestrictedAreaLng($event, i, pointIndex)
                    "
                    placeholder="0"
                    required
                    type="number"
                    [name]="'point' + i + 'Lng'"
                  />
                </mat-form-field>
                <mat-icon
                  (click)="removeRestrictedAreaPoint(i, pointIndex)"
                  [matTooltip]="'parameter.site.removePoint' | translate"
                  >delete_outlined</mat-icon
                >
              </div>
              <button
                mat-button
                class="stroked-pill-button"
                (click)="addRestrictedAreaPoint(i)"
              >
                <mat-icon
                  class="add-coordinate"
                  [matTooltip]="'parameter.site.addPoint' | translate"
                  >add</mat-icon
                >
              </button>
            </ng-container>
          </div>
          <button
            mat-button
            class="grid-item add-restricted-area"
            (click)="addRestrictedArea()"
          >
            <mat-icon
              class="add-coordinate"
              [matTooltip]="'parameter.site.addRestrictedArea' | translate"
              >add</mat-icon
            >
            {{ 'parameter.site.addRestrictedArea' | translate }}
          </button>
        </ng-container>
      </div>

      <!--
      Save Button
      -->
      <button mat-button class="pill-button save-button" (click)="onSave()">
        {{ 'parameter.general.save' | translate }}
      </button>
    </div>

    <div
      class="right-container"
      *ngIf="leafletOptions && leafletLayers && mapCenter"
    >
      <!-- 
        Mapbox Site 
      -->
      <div
        class="leaflet"
        leaflet
        [leafletOptions]="leafletOptions"
        [leafletLayers]="leafletLayers"
        [leafletCenter]="mapCenter"
      ></div>
    </div>
  </div>
</div>
